/*
	WARNING: This file was generated by dkct.
	Changes you make here will be lost if dkct is run again!
	You should modify the original source and run dkct on it.
	Original source: DkWxProgressDialog.wxc
*/

/*
Copyright (C) 2011-2013, Dirk Krause

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above opyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
* Neither the name of the author nor the names of contributors may be used
  to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/**	@file DkWxProgressDialog.h Header file for the DkWxProgressDialog module.
*/

#ifndef DKWXPROGRESSDIALOG_H_INCLUDED
/** Avoid multiple inclusions. */
#define DKWXPROGRESSDIALOG_H_INCLUDED 1


#line 58 "DkWxProgressDialog.wxc"

#include <DkWxCommunicator.h>




#line 64 "DkWxProgressDialog.wxc"

/**	Progress dialog showing currently process file, progress bar
	and a button to abort operation.
*/
class DkWxProgressDialog : public wxDialog
{
  private:
    /**	Event table.
    */
    DECLARE_EVENT_TABLE()

  protected:

    /**	Communicator object delivering the file name and progress bar
    	value.
    */
    DkWxCommunicator	*pComm;

    /**	String: Cancel operation scheduled. Please wait.
    */
    wxChar const	*sWaitPlease;

    /**	Parent frame.
    */
    DkWxFrame		*pParent;

    /**	Log text field to receive the messages.
    */
    wxTextCtrl		*pLogTextField;

    /**	Flag: GUI ok.
    */
    bool dkctGUILayoutOK;

    /**	GUI element sDialog.
    */
#line 15 "DkWxProgressDialog.wxc"
    wxBoxSizer *sDialog;

    /**	GUI element verticalSizer.
    */
#line 21 "DkWxProgressDialog.wxc"
    wxBoxSizer *verticalSizer;

    /**	GUI element sttFilename.
    */
#line 35 "DkWxProgressDialog.wxc"
    wxStaticText *sttFilename;

    /**	GUI element gaugeProgress.
    */
#line 41 "DkWxProgressDialog.wxc"
    wxGauge *gaugeProgress;

    /**	GUI element sttWait.
    */
#line 51 "DkWxProgressDialog.wxc"
    wxStaticText *sttWait;

    /**	GUI element bCancel.
    */
#line 46 "DkWxProgressDialog.wxc"
    wxButton *bCancel;


#line 95 "DkWxProgressDialog.wxc"
  public:

  /**	Constructor.
  	@param	parent		Parent window.
	@param	comm		Communicator object.
	@param	tc		Text control to show messages.
	@param	title		Title text.
	@param	firstFileName	First file name to show.
	@param	buttonText	Text for "Cancel" button.
	@param	buttonTip	Tooltip text for button.
	@param	waitText	Button to show while waiting for thread exit.
  */
  DkWxProgressDialog(
    DkWxFrame		*parent,
    DkWxCommunicator	*comm,
    wxTextCtrl		*tc,
    wxChar const	*title,
    wxChar const	*firstFileName,
    wxChar const	*buttonText,
    wxChar const	*buttonTip,
    wxChar const	*waitText
  );

  /**	Handler for idle events.
  	We request the current file name and progress bar from
	the communicator object and update the information shown
	in the dialog.
  */
  void
  OnIdle(wxIdleEvent & event);

  /**	Handler for cancel button.
  */
  void
  OnCancel(wxCommandEvent & WXUNUSED(event));

  /**	Choose a modal position centered on the parent.
  */
  void		 chooseModalPosition();

};




#line 140 "DkWxProgressDialog.wxc"


#endif
