/*
	WARNING: This file was generated by dkct.
	Changes you make here will be lost if dkct is run again!
	You should modify the original source and run dkct on it.
	Original source: DkWxTraceOptionsDialog.wxc
*/

/*
Copyright (C) 2011, Dirk Krause

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above opyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
* Neither the name of the author nor the names of contributors may be used
  to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/**	@file DkWxTraceOptionsDialog.h Header file for the DkWxTraceOptionsDialog module.
*/

#ifndef DKWXTRACEOPTIONSDIALOG_H_INCLUDED
/** Avoid multiple inclusions. */
#define DKWXTRACEOPTIONSDIALOG_H_INCLUDED 1


#line 129 "DkWxTraceOptionsDialog.wxc"


#line 131 "DkWxTraceOptionsDialog.wxc"
/**	Trace options dialog.
*/
class DkWxTraceOptionsDialog : public wxDialog
{
  private:

    /**	Event table.
    */
    DECLARE_EVENT_TABLE()

  protected:

    /**	Parent window.
    */
    DkWxTraceFrame	*pa;

    /**	Message texts.
    */
    wxChar const * const	*sTexts;

    /**	Option set to configure.
    */
    DKCT_OPTION_SET		*options;

    /**	Flag: We are in correction routine.
    */
    int				is_correcting;

    /**	Flag: GUI ok.
    */
    bool dkctGUILayoutOK;

    /**	GUI element sDialog.
    */
#line 13 "DkWxTraceOptionsDialog.wxc"
    wxBoxSizer *sDialog;

    /**	GUI element verticalSizer.
    */
#line 19 "DkWxTraceOptionsDialog.wxc"
    wxBoxSizer *verticalSizer;

    /**	GUI element sGeneral.
    */
#line 32 "DkWxTraceOptionsDialog.wxc"
    wxStaticBoxSizer *sGeneral;

    /**	GUI element sOutput.
    */
#line 48 "DkWxTraceOptionsDialog.wxc"
    wxStaticBoxSizer *sOutput;

    /**	GUI element sDebug.
    */
#line 76 "DkWxTraceOptionsDialog.wxc"
    wxStaticBoxSizer *sDebug;

    /**	GUI element sButtons.
    */
#line 114 "DkWxTraceOptionsDialog.wxc"
    wxStdDialogButtonSizer *sButtons;

    /**	GUI element sGeneralContents.
    */
#line 38 "DkWxTraceOptionsDialog.wxc"
    wxGridBagSizer *sGeneralContents;

    /**	GUI element cbMake.
    */
#line 44 "DkWxTraceOptionsDialog.wxc"
    wxCheckBox *cbMake;

    /**	GUI element sOutputContents.
    */
#line 54 "DkWxTraceOptionsDialog.wxc"
    wxGridBagSizer *sOutputContents;

    /**	GUI element cbLinenumbers.
    */
#line 62 "DkWxTraceOptionsDialog.wxc"
    wxCheckBox *cbLinenumbers;

    /**	GUI element cbUseSplint.
    */
#line 66 "DkWxTraceOptionsDialog.wxc"
    wxCheckBox *cbUseSplint;

    /**	GUI element chSplintChar.
    */
#line 71 "DkWxTraceOptionsDialog.wxc"
    wxChoice *chSplintChar;

    /**	GUI element sDebugContents.
    */
#line 82 "DkWxTraceOptionsDialog.wxc"
    wxGridBagSizer *sDebugContents;

    /**	GUI element cbDebug.
    */
#line 93 "DkWxTraceOptionsDialog.wxc"
    wxCheckBox *cbDebug;

    /**	GUI element cbDebStdout.
    */
#line 98 "DkWxTraceOptionsDialog.wxc"
    wxCheckBox *cbDebStdout;

    /**	GUI element cbDebTime.
    */
#line 102 "DkWxTraceOptionsDialog.wxc"
    wxCheckBox *cbDebTime;

    /**	GUI element cbDebTraceKw.
    */
#line 106 "DkWxTraceOptionsDialog.wxc"
    wxCheckBox *cbDebTraceKw;

    /**	GUI element cbDebWide.
    */
#line 110 "DkWxTraceOptionsDialog.wxc"
    wxCheckBox *cbDebWide;

    /**	GUI element bOK.
    */
#line 118 "DkWxTraceOptionsDialog.wxc"
    wxButton *bOK;

    /**	GUI element bCancel.
    */
#line 123 "DkWxTraceOptionsDialog.wxc"
    wxButton *bCancel;


#line 160 "DkWxTraceOptionsDialog.wxc"
  public:

    /**	Constructor.
  	@param	parent		Parent window.
	@param	title		Title text.
	@param	messageTexts	Localized message texts.
	@param	o		Options set to modify using this dialog.
    */
    DkWxTraceOptionsDialog(
      DkWxTraceFrame		*parent,
      wxChar const		*title,
      wxChar const * const	*messageTexts,
      DKCT_OPTION_SET		*o
    );

  protected:

    /**	Handler for OK button.
    	@param	event	Event to process.
    */
    void OnOK(wxCommandEvent& WXUNUSED(event));

    /**	Handler for Cancel button.
    	@param	event	Event to process.
    */
    void OnCancel(wxCommandEvent& WXUNUSED(event));

    /**	Handler for clicking the debug checkbox.
    	@param	event	Event to process.
    */
    void OnChangeDebug(wxCommandEvent & WXUNUSED(event));

    /**	Handler for changing the use splint option.
    	@param	event	Event to process.
    */
    void OnChangeUseSplint(wxCommandEvent & WXUNUSED(event));

  public:

    /**	Transfer data from GUI controls to configuration structure.
    */
    void dataOut();

    /**	Transfer data from configuration structure to GUI controls.
    */
    void dataIn();

    /**	Correct GUI depending on cbDebug.
    */
    void correctGUI();
};


#line 213 "DkWxTraceOptionsDialog.wxc"


#endif
