/*
	WARNING: This file was generated by dkct.
	Changes you make here will be lost if dkct is run again!
	You should modify the original source and run dkct on it.
	Original source: dk3trace.ctr
*/

/*
Copyright (C) 2011-2014, Dirk Krause

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice,
  this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above opyright notice,
  this list of conditions and the following disclaimer in the documentation
  and/or other materials provided with the distribution.
* Neither the name of the author nor the names of contributors may be used
  to endorse or promote products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/**	@file dk3trace.h Header file for the dk3trace module.
*/

#ifndef DK3TRACE_H_INCLUDED
/** Avoid multiple inclusions. */
#define DK3TRACE_H_INCLUDED 1


#line 10 "dk3trace.ctr"

#include "dk3conf.h"
#include "dk3types.h"

#include <stdio.h>

#if defined(__cplusplus)
extern "C" {
#endif



/**	Close trace output file.
*/
void
dktrace_end(void);



/**	Start tracing.
	@param	filename	File name to write trace output
	or NULL to use standard output.
*/
void
dktrace_init(
  char const *filename
);



/**	Get trace file.
	@return	Pointer to open file used for tracing.
*/
FILE *
dktrace_file(void);



/**	Close trace output file.
*/
void
dk_trace_end(void);



/**	Start tracing.
	@param	filename	File name to write trace output
	or NULL to use standard output.
*/
void
dk_trace_init(
  char const *filename
);



/**	Get trace file.
	@return	Pointer to open file used for tracing.
*/
FILE *
dk_trace_file(void);



/**	Write time to trace output.
*/
void
dktrace_time(void);



/**	Write time to trace output.
*/
void
dk_trace_time(void);



/**	Write time to standard output.
*/
void
dktrace_stdout_time(void);


#if DK3_ON_WINDOWS
/**	Write time to trace output.
*/
void
dk_trace_wtime(void);

/**	Write time to standard output.
*/
void
dktrace_stdout_wtime(void);

#endif

#if defined(__cplusplus)
}
#endif
/* ifdef __cplusplus */


#if TRACE_WIDE

/** Show string. */
#define TR_STR(x)	((x) ? (x) : L"(NULL)")

/** Show pointer. */
#define TR_PTR(x)	((x) ? L"PTR" : L"(NULL)")

/** Show long string. */
#define	TR_LSTR(x)	((x) ? (x) : L"(NULL)")

#else
/* if TRACE_WIDE */

/** Show string. */
#define TR_STR(x)	((x) ? (x) : "(NULL)")

/** Show pointer. */
#define TR_PTR(x)	((x) ? "PTR" : "(NULL)")

/** Show long string. */
#define	TR_LSTR(x)	((x) ? (x) : L"(NULL)")

#endif
/* if TRACE_WIDE */




#endif
